{%- set config = item.config|default({}) -%}

# If you come from bash you might have to change your $PATH.
{{ config | manala.roles.zsh_config_parameter('export PATH', comment='# export PATH=$HOME/bin:/usr/local/bin:$PATH') }}

# Path to your oh-my-zsh installation.
{{ config | manala.roles.zsh_config_parameter('export ZSH', default=manala_ohmyzsh_dir) }}

# Ensure per-user cache
{{ config | manala.roles.zsh_config_parameter('ZSH_CACHE_DIR', default='$HOME/.oh-my-zsh/cache') }}

if [[ ! -d $ZSH_CACHE_DIR ]]; then
  mkdir -p $ZSH_CACHE_DIR
fi

# Set name of the theme to load --- if set to "random", it will
# load a random theme each time oh-my-zsh is loaded, in which case,
# to know which specific one was loaded, run: echo $RANDOM_THEME
# See https://github.com/ohmyzsh/ohmyzsh/wiki/Themes
{{ config | manala.roles.zsh_config_parameter('ZSH_THEME', default='theme') }}

# Set list of themes to pick from when loading at random
# Setting this variable when ZSH_THEME=random will cause zsh to load
# a theme from this variable instead of looking in $ZSH/themes/
# If set to an empty array, this variable will have no effect.
{{ config | manala.roles.zsh_config_parameter('ZSH_THEME_RANDOM_CANDIDATES', comment='# ZSH_THEME_RANDOM_CANDIDATES=( "robbyrussell" "agnoster" )') }}

# Uncomment the following line to use case-sensitive completion.
{{ config | manala.roles.zsh_config_parameter('CASE_SENSITIVE', default=true, comment=true) }}

# Uncomment the following line to use hyphen-insensitive completion.
# Case-sensitive completion must be off. _ and - will be interchangeable.
{{ config | manala.roles.zsh_config_parameter('HYPHEN_INSENSITIVE', default=true, comment=true) }}

# Uncomment the following line to disable bi-weekly auto-update checks.
{{ config | manala.roles.zsh_config_parameter('DISABLE_AUTO_UPDATE', default=true, comment=true) }}

# Uncomment the following line to automatically update without prompting.
{{ config | manala.roles.zsh_config_parameter('DISABLE_UPDATE_PROMPT', default=true, comment=true) }}

# Uncomment the following line to change how often to auto-update (in days).
{{ config | manala.roles.zsh_config_parameter('export UPDATE_ZSH_DAYS', default=13, comment=true) }}

# Uncomment the following line if pasting URLs and other text is messed up.
{{ config | manala.roles.zsh_config_parameter('DISABLE_MAGIC_FUNCTIONS', default=true, comment=true) }}

# Uncomment the following line to disable colors in ls.
{{ config | manala.roles.zsh_config_parameter('DISABLE_LS_COLORS', default=true, comment=true) }}

# Uncomment the following line to disable auto-setting terminal title.
{{ config | manala.roles.zsh_config_parameter('DISABLE_AUTO_TITLE', default=true, comment=true) }}

# Uncomment the following line to enable command auto-correction.
{{ config | manala.roles.zsh_config_parameter('ENABLE_CORRECTION', default=true, comment=true) }}

# Uncomment the following line to display red dots whilst waiting for completion.
# Caution: this setting can cause issues with multiline prompts (zsh 5.7.1 and newer seem to work)
# See https://github.com/ohmyzsh/ohmyzsh/issues/5765
{{ config | manala.roles.zsh_config_parameter('COMPLETION_WAITING_DOTS', default=true, comment=true) }}

# Uncomment the following line if you want to disable marking untracked files
# under VCS as dirty. This makes repository status check for large repositories
# much, much faster.
{{ config | manala.roles.zsh_config_parameter('DISABLE_UNTRACKED_FILES_DIRTY', default=true, comment=true) }}

# Uncomment the following line if you want to change the command execution time
# stamp shown in the history command output.
# You can set one of the optional three formats:
# "mm/dd/yyyy"|"dd.mm.yyyy"|"yyyy-mm-dd"
# or set a custom format using the strftime function format specifications,
# see 'man strftime' for details.
{{ config | manala.roles.zsh_config_parameter('HIST_STAMPS', default='mm/dd/yyyy', comment=true) }}

# Would you like to use another custom folder than $ZSH/custom?
{{ config | manala.roles.zsh_config_parameter('ZSH_CUSTOM', comment='# ZSH_CUSTOM=/path/to/new-custom-folder') }}

# Which plugins would you like to load?
# Standard plugins can be found in $ZSH/plugins/
# Custom plugins may be added to $ZSH_CUSTOM/plugins/
# Example format: plugins=(rails git textmate ruby lighthouse)
# Add wisely, as too many plugins slow down shell startup.
{{ config | manala.roles.zsh_config_parameter('plugins', default=['git', 'debian', 'common-aliases', 'history', 'history-substring-search']) }}

source $ZSH/oh-my-zsh.sh

# User configuration

{{ config | manala.roles.zsh_config_parameter('export MANPATH', default='/usr/local/man:$MANPATH', comment=true) }}

# You may need to manually set your language environment
{{ config | manala.roles.zsh_config_parameter('export LANG', comment='# export LANG=en_US.UTF-8') }}

# Preferred editor for local and remote sessions
# if [[ -n $SSH_CONNECTION ]]; then
#   export EDITOR='vim'
# else
#   export EDITOR='mvim'
# fi

# Compilation flags
{{ config | manala.roles.zsh_config_parameter('export ARCHFLAGS', default='-arch x86_64', comment=true) }}

# Set personal aliases, overriding those provided by oh-my-zsh libs,
# plugins, and themes. Aliases can be placed here, though oh-my-zsh
# users are encouraged to define aliases within the ZSH_CUSTOM folder.
# For a full list of active aliases, run `alias`.
{{ config | manala.roles.zsh_config_parameter('alias', comment='#\n# Example aliases\n# alias zshconfig="mate ~/.zshrc"\n# alias ohmyzsh="mate ~/.oh-my-zsh"') }}

{{ config | manala.roles.zsh_config(exclude=[
  'export PATH',
  'export ZSH',
  'ZSH_CACHE_DIR',
  'ZSH_THEME',
  'ZSH_THEME_RANDOM_CANDIDATES',
  'CASE_SENSITIVE',
  'HYPHEN_INSENSITIVE',
  'DISABLE_AUTO_UPDATE',
  'DISABLE_UPDATE_PROMPT',
  'UPDATE ZSH_DAYS',
  'DISABLE_MAGIC_FUNCTIONS',
  'DISABLE_LS_COLORS',
  'DISABLE_AUTO_TITLE',
  'ENABLE_CORRECTION',
  'COMPLETION_WAITING_DOTS',
  'DISABLE_UNTRACKED_FILES_DIRTY',
  'HIST_STAMPS',
  'ZSH_CUSTOM',
  'plugins',
  'export MANPATH',
  'export LANG',
  'export ARCHFLAGS',
  'alias'
]) }}
